
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何优雅的在 koa 中处理错误 / iVAN</title>

    <meta name="description" content="如何优雅的在 koa 中处理错误 软件开发时,有 80% 的代码在处理各种错误. --某著名开发者 想让自己的代码健壮,错误处理是必不可少的.这篇文章将主要介绍 koa 框架中错误处理的实现(其实主要是 co 的实现),使用 koa 框架开发 web 应用时进行错误处理的一些方法. 基础 在 Node.js 中,错误处理的方法主要有下面几种: 和其他同步语言类似的 throw / try / catch 方法 callback(err, data) 回调形式 通过 EventEmitter 触发一个 error 事件 第一种使用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何优雅的在 koa 中处理错误</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p>软件开发时，有 80% 的代码在处理各种错误。</p>
<p>——某著名开发者</p></blockquote>
<p>想让自己的代码健壮，错误处理是必不可少的。这篇文章将主要介绍 koa 框架中错误处理的实现（其实主要是 co 的实现），使用 koa 框架开发 web 应用时进行错误处理的一些方法。</p>
<h2>基础</h2>
<p>在 Node.js 中，错误处理的方法主要有下面几种：</p>
<ul>
<li>和其他同步语言类似的 throw / try / catch 方法</li>
<li>callback(err, data) 回调形式</li>
<li>通过 EventEmitter 触发一个 error 事件</li>
</ul>
<p>第一种使用 catch 来捕获错误，十分易用，其他两种在捕获错误时多多少少都有些别扭。</p>
<p>但是 koa 通过十分巧妙的”黑魔法“让我们可以使用 catch 来捕获异步代码中的错误。比如下面的例子：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>const fs = require('fs');const Promise = require('bluebird');

let filename = '/nonexists';let statAsync = Promise.promisify(fs.stat);try {  yield statAsync(filename);} catch(e) {  // error here}</pre>
</td>
</tr>
</tbody>
</table>
<p>在 koa 中，推荐统一使用 throw / try / catch 的方式来进行错误的触发和捕获，这会让代码更加易读，防止被绕晕。</p>
<h2>原理</h2>
<p>上面我们说了 koa 中可以使用 try / catch，我们就来分析下它是如何做到的。koa 基于 co，所以，我们其实主要是分析 co 的实现。（注：这一部分比较偏原理，不关心的可以跳过。）</p>
<p>首先，我们来看看什么是 generator。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>function* gen() {  var a = yield 'start';  console.log(a);  var b = yield 'end';  console.log(b);  return 'over';}var it = gen();console.log(it.next()); // {value: 'start', done: false}console.log(it.next(22)); // 22 {value: 'end', done: false}console.log(it.next(333)); // 333 {value: 'over', done: true}</pre>
</td>
</tr>
</tbody>
</table>
<p>带有 <code>*</code> 的函数声明表示是一个 generator 函数，当执行 <code>gen()</code> 时，函数体内的代码并没有执行，而是返回了一个 generator 对象。</p>
<p>generator 函数通常和 yield 结合使用，函数执行到每个 yield 时都会暂停并返回 yield 的右值。下次调用 next 时，函数会从 yield 的下一个语句继续执行。等到整个函数执行完，next 方法返回的 done 字段会变成 true，并且将函数返回值作为 value 字段。</p>
<p>第一次执行 <code>next()</code> 时，走到 <code>yield 'start'</code> 后暂停并返回 <code>yield</code> 的右值 <code>'start'</code>。注意，此时<code>var a =</code> 这个赋值语句其实还没有执行。</p>
<p>第二次执行 <code>next(22)</code> 时，从 <code>yield 'start'</code> 下一个语句执行。于是执行 <code>var a =</code> 这个赋值语句，而表达式 <code>yield 'start'</code> 的值就等于传递给 <code>next</code> 函数的参数值 <code>22</code>，所以，<code>a</code> 被赋值为 <code>22</code>。然后继续往下执行到 <code>yield 'end'</code> 后暂停并返回 <code>yield</code> 的右值 <code>'end'</code>。</p>
<p>第三次执行 <code>next(333)</code> 时，从 <code>yield 'end'</code> 下一个语句执行。此时执行 <code>var b =</code> 这个赋值语句，表达式 <code>yield 'end'</code> 的值等于传递给 <code>next</code> 函数的参数 <code>333</code>，<code>b</code> 被赋值为 <code>333</code>。继续往下执行到 <code>return</code> 语句，将 <code>return</code> 语句的返回值作为 <code>value</code> 返回，因为函数已经执行完毕，<code>done</code> 字段标记为 <code>true</code>。</p>
<p>可以看到 generator 就是一种迭代机制，就像一只很懒的青蛙，戳一下（调用 <code>next</code>）动一下。</p>
<p>generator 对象还有一个 <code>throw</code> 方法，可以在 generator 函数外面抛出异常，然后在 generator 函数里面捕获异常。有点绕？我们来看一个实例：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>function *gen() {  try {    yield 'a';    yield 'b';  } catch(e) {    console.log('inside：', e); // inside： [Error: error from outside]  }}

var it = gen();it.next();

console.log(it.throw(new Error('error from outside'))); // { value: undefined, done: true }</pre>
</td>
</tr>
</tbody>
</table>
<p>我们执行一次 <code>next</code>，会运行到 <code>yield 'a'</code> 这里然后暂停，这一句刚好在 try 的返回内，因此 <code>it.throw</code> 抛出的错误我们可以 catch 到。并且看到 <code>throw</code> 返回的 <code>done</code> 字段是 <code>true</code>，说明后面的 <code>yield 'b'</code> 已经不会再执行了。</p>
<p>如果我们不调用 <code>next</code>，或者连续调用三次 <code>next</code>，<code>yield</code> 代码不在 <code>try</code> 返回里面，会导致报错。co 的错误处理其实正是利用了这个 <code>throw</code> 方法。</p>
<p>下面我们来看看 co 的核心代码：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>function co(gen) {  var ctx = this;  var args = slice.call(arguments, 1);

// 统一返回一个整体的 promise  return new Promise(function(resolve, reject) {    // 如果是函数，调用并取得 generator 对象    if (typeof gen === 'function') gen = gen.apply(ctx, args);    // 如果根本不是 generator 对象（没有 next 方法），直接 resolve 掉并返回    if (!gen || typeof gen.next !== 'function') return resolve(gen);

// 入口函数    onFulfilled();

function onFulfilled(res) {      var ret;      try {        // 拿到 yield 的返回值        ret = gen.next(res);      } catch (e) {        // 如果执行发生错误，直接将 promise reject 掉        return reject(e);      }      // 延续调用链      next(ret);    }    function onRejected(err) {      var ret;      try {        // 如果 promise 被 reject 了就直接抛出错误        ret = gen.throw(err);      } catch (e) {        // 如果执行发生错误，直接将 promise reject 掉        return reject(e);      }      // 延续调用链      next(ret);    }    function next(ret) {      // generator 函数执行完毕，resolve 掉 promise      if (ret.done) return resolve(ret.value);      // 将 value 统一转换为 promise      var value = toPromise.call(ctx, ret.value);      // 将 promise 添加 onFulfilled、onRejected，这样当新的promise 状态变成成功或失败，就会调用对应的回调。整个 next 链路就执行下去了      if (value &amp;&amp; isPromise(value)) return value.then(onFulfilled, onRejected);      // 没法转换为 promise，直接 reject 掉 promise      return onRejected(new TypeError('You may only yield a function, promise, generator, array, or object, '        + 'but the following object was passed: "' + String(ret.value) + '"'));    }  });}</pre>
</td>
</tr>
</tbody>
</table>
<p>假设有下面的代码，让我们一起推演下执行流程：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>co(function* gen() {  var a = yield Promise.resolve('a 值');  console.log(a);  try {    var b = yield Promise.reject(new Error('b 错误'));    var c = yield Promise.resolve('c 值');    console.log(b, c);  } catch(e) {    console.log('error', e);  }  return 'over';}).then(function (value) {  console.log(value);}).catch(function (err) {  console.error(err.stack);});</pre>
</td>
</tr>
</tbody>
</table>
<p>约定：<code>Promise.resolve('a 值')</code> 生成的是 promiseA；<code>Promise.reject(new Error('b 错误'))</code>生成的是 promiseB。</p>
<p>首先传入 co 的 gen 函数会被执行，获取到 generator 对象。对应代码：<code>if (typeof gen === 'function') gen = gen.apply(ctx, args);</code>。</p>
<p>然后调用 <code>onFulfilled</code> 函数。开启整个执行过程。</p>
<p>第一次执行 <code>ret = gen.next(res)</code>，走到 <code>yield Promise.resolve('a 值')</code> 后暂停并返回 <code>yield</code>的右值，此时 <code>ret</code> 等于 <code>{value: PromiseA, done: false}</code>。</p>
<p>然后执行 <code>next(ret)</code>，将 <code>ret.value</code> 转换为 Promise，执行 <code>value.then(onFulfilled, onRejected)</code>，也就是 <code>PromiseA.then(onFulfilled, onRejected)</code>。当我们的 PromiseA 被 resolve 后，又再次执行 <code>onFulfilled</code>，并传入 resvole 的值，也就是：<code>onFulfilled('a 值')</code>。</p>
<p>于是第二次执行 <code>ret = gen.next('a 值')</code>（此时的 <code>res</code> 就等于 <code>a 值</code>），进入到 gen 函数，执行接下来的 <code>var a =</code> 赋值语句，<code>yield Promise.resolve('a 值')</code> 的返回值等于给 <code>next</code> 传递的参数 <code>'a 值'</code>，于是变量 <code>a</code> 被赋值为 <code>'a 值'</code>。继续执行到 <code>yield Promise.reject(new Error('b 错误'))</code> 后暂停并返回 <code>yield</code> 的右值，此时 <code>ret</code> 等于 <code>{value: PromiseB, done: false}</code>。</p>
<p>继续执行 <code>next(ret)</code>，延续调用链。执行 <code>value.then(onFulfilled, onRejected)</code>，也就是<code>PromiseB.then(onFulfilled, onRejected)</code>。这次 PromiseB 被 reject 掉了，于是执行<code>onRejected</code>，并传人 reject 的错误原因，也就是：<code>onRejected(new Error('b 错误'))</code>。</p>
<p>于是执行到 <code>ret = gen.throw(new Error('b 错误'))</code>，而此时 <code>yield Promise.reject(new Error('b 错误'))</code> 刚好在 try 的范围内，错误被 catch 住了！接着就执行 catch 里面的打印语句<code>console.log('error', e);</code>，一路执行到函数结束（因为再也没有 <code>yield</code> 了），将返回值赋给<code>value</code>。最后 <code>ret</code> 等于 <code>{value: 'over', done: true}</code>。</p>
<p>继续执行 <code>next(ret)</code>，延续调用链。执行到 <code>if (ret.done) return resolve(ret.value);</code>，于是整体的 promise 被 resolve 掉，执行 <code>then</code> 里面的打印语句，打印出 <code>ret.value</code> 的值<code>'over'</code>。整个流程结束。</p>
<p>如果我们不 try / catch 会怎样？因为 <code>onRejected</code> 里面有是这样处理的：<code>try { ret = gen.throw(err); } catch (e) { return reject(e); }</code>。我们上面说如果 <code>yield</code> 没有在 <code>try</code>里会导致 <code>gen.throw</code> 报错，于是整体 promise 被 reject，执行其 <code>catch</code> 方法，打印出 <code>Error('b 错误')</code> 的堆栈。</p>
<p>这就是“黑魔法”的神秘面纱！对 TJ 大神真是一个大写的“服”字。</p>
<h2>什么错误该处理和怎么处理</h2>
<p>接下来的问题是什么样的错误我们需要处理？怎么处理？我们可以将错误分个类：</p>
<ul>
<li>操作错误：不是程序 bug 导致的运行时错误。比如：连接数据库服务器失败、请求接口超时、系统内存用光等等。</li>
<li>程序错误：程序 bug 导致的错误，只要修改代码就可以避免。比如：尝试读取未定义对象的属性、语法错误等等。</li>
</ul>
<p>很显然，我们真正需要处理的是操作错误，程序错误应该马上进行修复。</p>
<p>那怎么处理操作错误呢？总结起来大概有下面这些方法：</p>
<ul>
<li>直接处理。这个简直是废话。举个例子：尝试向一个文件中写东西，但是这个文件不存在，那这个时候会报错吧？处理这个错误的方法就是先创建好要写入的文件。如果我们知道怎么处理错误，那直接处理就是。</li>
<li>重试。有时候某些错误可能是偶发的（比如：连接的服务不稳定等），我们可以尝试对当前操作进行重试。但是一定要设置重试的超时时间、次数，避免长时间的等待卡死应用。</li>
<li>直接将错误抛给调用方。如果我们不知道具体怎么处理错误，那最简单的就是将错误往上抛。比如：检查到用户没有权限访问某个资源，那我们直接 throw 一个 Error（并带上 status 是 403）比较好，上层代码可以 catch 这个错误，然后要么展示一个统一的无权限页面给用户，要么返回一个统一的错误 json 给调用方。</li>
<li>写日志然后将错误抛出。这种情况一般是发生了比较致命的错误，没法处理，也不能重试，那我们需要记下错误日志（方便以后定位问题），然后将错误往上抛（交给上层代码去进行统一错误展示）。</li>
</ul>
<h2>使用中间件统一处理错误</h2>
<p>有了上面的说明，那现在我们就来看看在 koa 里面怎么优雅的实现统一错误处理。</p>
<p>答案就是使用强大的中间件！</p>
<p>我们可以在业务逻辑中间件（一般就是 MVC 中的 Controller）开始之前定义下面的中间件：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>app.use(function* (next) {  try {    yield* next;  } catch(e) {    let status = e.status || 500;    let message = e.message || '服务器错误';

if (e instanceof JsonError) { // 错误是 json 错误      this.body = {        'status': status,        'message': message      };      if (status == 500) {         // 触发 koa 统一错误事件，可以打印出详细的错误堆栈 log        this.app.emit('error', e, this);      }      return;    }

this.status = status;    // 根据 status 渲染不同的页面    if (status == 403) {      this.body = yield this.render('403.html', {'err': e});    }    if (status == 404) {      this.body = yield this.render('404.html', {'err': e});    }    if (status == 500) {      this.body = yield this.render('500.html', {'err': e});      // 触发 koa 统一错误事件，可以打印出详细的错误堆栈 log      this.app.emit('error', e, this);    }  }});</pre>
</td>
</tr>
</tbody>
</table>
<p>可以看到，我们直接执行 <code>yield* next</code>，然后 <code>catch</code> 执行过程中任何一个中间件的错误，然后根据错误的“特性”，分别进行不同的处理。</p>
<p>有了这个中间件，我们的业务逻辑 controller 中的代码就可以这样来触发错误：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>const router = new (require('koa-router'));

router.get('/some_page', function* () {  // 直接抛出错误，被中间件捕获后当成 500 错误  throw new PageError('发生了一个致命错误');   throw new JsonError('发送了一个致命错误');

// 带 status 的错误，被中间件捕获后特殊处理  this.throw(403, new PageError('没有权限访问'));  this.throw(403, new JsonError('没有权限访问'));});</pre>
</td>
</tr>
</tbody>
</table>
<h2>对 Error 分类</h2>
<p>上面的代码里面出现的 <code>JsonError</code>、<code>PageError</code>，实际上是继承于 <code>Error</code> 的两个构造器。代码如下：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>const util = require('util');

exports.JsonError = JsonError;exports.PageError = PageError;

function JsonError(message) {  Error.call(this, message);}util.inherits(JsonError, Error);

function PageError(message) {  Error.call(this, message);}util.inherits(PageError, Error);</pre>
</td>
</tr>
</tbody>
</table>
<p>通过继承 <code>Error</code> 构造器，我们可以将错误进行细分，从而能更精细的对错误进行处理。</p>
<h2>参考资料</h2>
<ul>
<li><a href="https://www.joyent.com/developers/node/design/errors" rel="external nofollow noreferrer">https://www.joyent.com/developers/node/design/errors</a></li>
<li><a href="https://github.com/koajs/koa/wiki/Error-Handling" rel="external nofollow noreferrer">https://github.com/koajs/koa/wiki/Error-Handling</a></li>
<li><a href="https://imququ.com/post/generator-function-in-es6.html" rel="external nofollow noreferrer">https://imququ.com/post/generator-function-in-es6.html</a></li>
<li><a href="http://purplebamboo.github.io/2014/05/24/koa-source-analytics-1/" rel="external nofollow noreferrer">http://purplebamboo.github.io/2014/05/24/koa-source-analytics-1/</a></li>
<li><a href="http://purplebamboo.github.io/2015/01/16/koa-source-analytics-4/" rel="external nofollow noreferrer">http://purplebamboo.github.io/2015/01/16/koa-source-analytics-4/</a></li>
</ul>
<p>转载自：http://taobaofed.org/blog/2016/03/18/error-handling-in-koa/</p>
<p>作者：栖邀</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:33:37</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/node-js/" title="Node&period;js">Node&period;js</a>, <a href="https://www.iamivan.net/tag/koa/" title="Koa">Koa</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何优雅的在 koa 中处理错误的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLg06LM.html" rel="bookmark">&lbrack;译&rsqb; RxJava 中的错误处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] RxJava 中的错误处理, 原文地址:Error handling in RxJava 原文作者:Dmitry Ryadnenko 译文出自:掘金翻译计划 本文永久链接:github.com/xitu/gold-m- 译者:星辰 校对者:张拭心 Liz Drawing 一旦你开始使用 RxJava 函数库写代码,你会发现一些东西能有很多不同的实现方式,但是有时你很难立即确定哪种方法最好,错误处理就是其中之一. 那么,在 RxJava 中处理错误的最佳方法是什么,又有哪些选择呢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPZWN1b.html" rel="bookmark">express请求流中的错误捕捉处理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				nodejs中的错误处理还是比较麻烦的,尤其遇到异步回调之类,多层嵌套,简单的try-catch无法处理. 目前在用expressjs,拿此举例说说怎样实践. 第一种,从一介布衣那儿看到的方法,可行: const domain = require('domain'); app.use((req, res, next) =&gt; {   const reqDomain = domain.create();   // next抛出的异常在这里被捕获,触发此事件   reqDomain.on('error			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5Y2Wp.html" rel="bookmark">库-调试批处理运行DLL中的错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 调试批处理运行DLL中的错误 各位大神好, 我做了个批处理,循环多次执行做的DLL库时,有时候dll库会崩掉. 但是又不能定位到底是DLL哪里的问题. 有什么方法,能调试到批处理循环中DLL崩掉的语句吗? 谢谢了 解决方案 androi的可以, 其它的不知道 解决方案二: 建一个日志文件,在值得怀疑的地方向文件写一些变量值. 出问题了,分析日志,能大概知道是哪个函数哪个位置出问题了. 解决方案三: 建一个日志文件,在值得怀疑的地方向文件写一些变量值. 出问题了,分析日志,能大概知道是哪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRdvGz.html" rel="bookmark">C&plus;&plus;系统中指针错误，添加不了对象，真的很急！！！！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C++系统中指针错误,添加不了对象,真的很急!!!! 为什么不能实现添加啊!!!!!真的很急 #include &lt;iostream&gt;#include &lt;iomanip&gt;#include &lt;conio.h&gt;#include &lt;string&gt;#include &lt;fstream&gt;#include &lt;cstdlib&gt;using namespace std;int i=0;const int Maxp=100;//最大商品类的数量cl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpnrZrp.html" rel="bookmark">在SQLServer的存储过程中处理错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|sqlserver|存储过程|错误 SQL Server 存储进程中的&quot;错误处理&quot;只是向客户端返回错误,通常访问提供者可以自己做.但是至少你可以知道在执行T-SQL的时候何止发生了何种错误.本文中,我会介绍在 你错了 SQL Server 有接近3800个预定义错误代码,由主目录的sysmessages表维护.每一个错误代码都有相应的精确的级别,该级别大致描述了错误.错误定义的级别从0到25.20以上的错误代表重大错误,通常意味着该错误会导致存储进程立刻终止,并且所有的客			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjJBdb.html" rel="bookmark">ASP&period;NET中的错误处理支持&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|错误|错误处理 ASP.NET中的错误处理支持 ASP.NET具有一个很好的新功能:它对运行时间错误的处理和跟踪提供了丰富支持.特别是,它为管理人员提供了一种很简单的方法,可以保证那些令人恐惧的&quot;ASP 43433ax&quot;十六进制形式的错误永远也不会被显示到客户面前.相反,它允许显示一个较为定制化的信息,比如&quot;对不起,这个站点不可用&quot;.ASP.NET还提供了一种强大的方法,使开发人员可以对他们的代码进行装备,向管理人员提供发生在工作站点问题的额外信息与			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YbKPq7M.html" rel="bookmark">以前搜集的一些资料---如何在ASP中实现错误陷阱技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				错误 如何在ASP中实现错误陷阱技术(即实现VB中的所谓的On Error GoTo)代码如下(一共4个文件)1.error1.asp(用来生成错误)&lt;html&gt;&lt;head&gt;&lt;title&gt;输入数据&lt;/title&gt;&lt;/head&gt; &lt;body&gt; &lt;form method=&quot;POST&quot; action=&quot;error2.asp&quot; name=&quot;form1&quot;&gt;  &lt;div			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAaaYeM.html" rel="bookmark">JSP最佳实践&colon; 自定义标记中的错误处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:在自定义标记中引用更多交互性的同时,也会增加错误出现的可能性,尤其是以非法参数形式 出现的错误.在本期的 JSP最佳实践中,Brett McLaughlin 向您展示了如何在源代码中捕获和忽略 IllegalArgumentException 异常. 在我们讨论 JSP 自定义标记的时候,我们一直都设法回避了错误处理的重要细节.在我们已经推出的 JSP 最佳实践系列的前面一半的文章中,大多数讲的都是 JSP 容器提供的功能,比如说 param . out 和 import 标记.在这些情况			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKdnVp.html" rel="bookmark">用Xdebug修正PHP应用程序中的错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:PHP 的 Xdebug 扩展可以帮助您在程序出错或失败时剖析应用程序以查找原因.通过本文了解 如何使用 Xdebug 跟踪调用堆栈.分析内存使用情况并查看参数和变量的内容. 虽然您可以使用 PHP 为系统管理和传统数据处理之类的任务创建命令行脚本,但是编程语言对 Web 应用程序的性能有主要影响.在使用过程中,每个 PHP 应用程序都驻留在服务器上,并且将通过代理( 例如 Apache)调用 PHP 应用程序处理到来的请求.对于每个请求,典型的 PHP Web 应用程序在简短运 行后将得			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwO6mz.html" rel="bookmark" class="title">如何用Jsp读取Mysql数据库</a>
					<div>
						js|mysql|数据|数据库 &lt;%//说明count是总的记录的条数 //page是用户提交的参数,用于控制分页的,允许的值是正整数,负整数 int i=count/15; //总页,每页显示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv0Xrz.html" rel="bookmark" class="title">电商网站基本模块网页标题描写方法</a>
					<div>
						一.什么是网页标题 在浏览一个网页时,通过浏览器顶端的蓝色显示条出现的信息就是&quot;网页标题&quot;. 如下图所示.网页标题就是整个网页的题目,是对其内容的高度概括和总结.网页标题作为网友第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE1eZb.html" rel="bookmark" class="title">为何Windows XP下卸载驱动重启后又恢复</a>
					<div>
						近日,对一上网本进行了系统的安装,使用无线网络一直处于正在连接的状态,查看了官方的说法后,发现安装的无线网卡的驱动版本是有问题的,就想到要卸载现在的驱动,安装最新的驱动,在卸载后再次重启后,又被自动安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOwqkb.html" rel="bookmark" class="title">ASP&period;NET Debug系列之三：Crash调试</a>
					<div>
						前两天翻译了Tess Debug系列的Hang调试,今天就继续和大家看看Tess的第三篇文章,Crash调试.同样,由于机器的差异,可能你的调试结果和Tess有所差异,不过这个不要紧,只要你知道其中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balOKqz.html" rel="bookmark" class="title">Win7系统网页报错&OpenCurlyDoubleQuote;无法解析服务器的DNS地址&rdquo;怎么办？</a>
					<div>
						  Win7系统网页报错&quot;无法解析服务器的DNS地址&quot;怎么办?           方法一: 1.点击开始菜单,在搜索框内输入&quot;cmd&quot;,然后在搜索出的程序中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLlyZb.html" rel="bookmark" class="title">php查询mysql数据库并将结果保存到数组的方法</a>
					<div>
						 这篇文章主要介绍了php查询mysql数据库并将结果保存到数组的方法,实例分析了php使用mysql_fetch_assoc查询数据库的技巧,需要的朋友可以参考下     本文实例讲述了php查询m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx1l2b.html" rel="bookmark" class="title">Excel教你巧用热键任移方向</a>
					<div>
						  在使用Excel时,当活动单元格中输入数据完毕,按下回车键后,插入点移动到其下面的单元格中.这时,或许你并不希望插入点下移,而是需要插入点移到相邻的其他单元格.那么下述的热键或许能够满足你的需要. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7AK5M.html" rel="bookmark" class="title">JavaScript获取表单enctype属性的方法</a>
					<div>
						 本文实例讲述了JavaScript获取表单enctype属性的方法.分享给大家供大家参考.具体如下:   1 2 3 4 5 6 7 8 9 10 11 12 13 14 &lt;!DOCTYPE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywd64z.html" rel="bookmark" class="title">Linux下的无名管道pipe的设计</a>
					<div>
						  1. 函数说明 pipe(建立管道): 1) 头文件 #include 2) 定义函数: int pipe(int filedes[2]); 3) 函数说明: pipe()会建立管道,并将文件描述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Xxmp.html" rel="bookmark" class="title">Photoshop制作华丽大气的立体花纹</a>
					<div>
						花纹素材有很多,需要的时候,我们可以用图层样式等增加颜色.质感.纹理,就可以得到相当不错的效果,可更好装饰画面. 最终效果 1.新建一个800 * 800像素的文件,选择渐变工具,颜色设置为红色至暗红 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZGeVz.html" rel="bookmark" class="title">电脑的刷新有什么用？</a>
					<div>
						在日常生活中,肯定有很多朋友和小编一样,在开机的时候狂按F5或者右键刷新,这是一个习惯问题,但是你有想过刷新有什么作用吗?有的朋友说刷新可以解决内存,像电脑卡的时候,按下F5,电脑就好多了.但是小编在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaLJAz.html" rel="bookmark" class="title">笔记本拆装维修基础</a>
					<div>
						  笔记本电脑是精密的高科技设备,即使专业人员也是非常仔细和小心拆装,其拆装前和拆装后应注意的事项有; 1.释放自身的静电,可以接触金属物体或用水洗手. 2.拆卸前务必关闭电源,拆去外围设备,如AC适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ5wep.html" rel="bookmark" class="title">qsv格式是什么的文件</a>
					<div>
						  qsv格式是爱奇艺公司研发的一种视频文件格式,由于正版视频需要版权保护加上QSV文件是一种缓存文件,所以以往qsv不能用常规的格式(格式工厂等)转换软件进行转换. qsv是一个视频加速的格式,这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72q1ap.html" rel="bookmark" class="title">GPU芯片组的区别</a>
					<div>
						  装机我们经常听到G31 .P31. G41. P43等专业术语,普通人不知道是什么意思,其实就是芯片组的不同叫法,都是INTER公司的产品,差异主要在于是否带有集成显卡 比如G31的集成显卡是 I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42VL1M.html" rel="bookmark" class="title">Aero Peek桌面是什么意思？</a>
					<div>
						  并不是所有的win7操作系统都有Aero Peek桌面功能 1.系统的版本要home premium或以上,才有Aero peek 效果. 2.你所选择的要是 Aero主题 3.在系统属性的性能选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWeB0b.html" rel="bookmark" class="title">蓝桥杯 c c&plus;&plus; 编程-请大神指导，不懂哪里错了</a>
					<div>
						问题描述 请大神指导,不懂哪里错了 这是杨辉三角,蓝桥杯的试题,试了几组数据都是对的,可是提交上去却是零分,不懂哪里错了,求指导,谢谢 解决方案 题目是这个,照片不清楚,拜托了! 问题描述 杨辉三角形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZlN2z.html" rel="bookmark" class="title">ExpensiveWall：&OpenCurlyDoubleQuote;包装&rdquo;恶意软件现身 Google Play，危及用户财产安全</a>
					<div>
						Check Point 的移动威胁研究团队发现了一款 Android 恶意软件的新变体,该软件会向用户发送欺诈性收费 SMS 消息,并在其毫不知情的情况下向用户账号收取虚假服务费.根据 Google  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e8yLb.html" rel="bookmark" class="title">javase-关于java进阶的问题。</a>
					<div>
						问题描述 关于java进阶的问题. 已经学完了javase,想写些桌面级的应用程序,但发现只能写些像计算器等这样的小程序,想做些音乐播放器,截屏软件类似这样的程序该看些什么?求大神们指导下,该看什么书 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7GaKz.html" rel="bookmark" class="title">容量再次飙升 希捷推出10TB硬盘组合</a>
					<div>
						  希捷日前发布了Guardian 守护者系列全新10TB大容量硬盘组合.希捷10TB BarraCuda Pro台式机硬盘.IronWolf NAS硬盘和SkyHawk监控硬盘系为帮助客户更好地管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQnAap.html" rel="bookmark" class="title">【Java集合系列】---总体框架</a>
					<div>
						集合--童年的美好时光 集合,忽然让小编想起那段美好的学生时光,集合第一次遇见她的时候,小编当年还是一个懵懂的丫头,也不曾想过会在计算机的世界再次相遇,再回首,集合在数学中是一个基本概念,集合就是&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAavOM.html" rel="bookmark" class="title">json-JSONOject对象中has方法与containskey 方法的区别？</a>
					<div>
						问题描述 JSONOject对象中has方法与containskey 方法的区别? 项目开发中,使用JSONObject解析json消息,判断json消息中是否包括某个key时,使用has方法.con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWl0Oz.html" rel="bookmark" class="title">【工具】基准测试工具之iozone</a>
					<div>
						  IOzone是一个文件系统测试工具,可以用来测试磁盘IO的读写性能,可以在各种操作系统上面使用. 下载 从官网 http://www.iozone.org/ 可以下载rpm 包,源文件进行安装.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgKB6b.html" rel="bookmark" class="title">非常急</a>
					<div>
						问题描述 怎么把sqlserver2008r2的数据库附加到sqlsever2005上使用的版本 解决方案 解决方案二:不能附加,可以先生成脚本文件,再把数据导过去.解决方案三:高版本如果用到了低版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydqqPb.html" rel="bookmark" class="title">56网周娟：要卖就要快！</a>
					<div>
						本报记者 施建 广州报道 八年浪淘沙,网络视频的淘汰战仍未完结. &quot;入行以来,没睡过几天好觉.&quot;56网副总裁李浩对记者表示,从那时到现在,不知多少视频网站灰飞烟灭,&quot;生存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z407qYz.html" rel="bookmark" class="title">微信 获取wx&period;config 参数 基类</a>
					<div>
						原文:微信 获取wx.config 参数 基类 using System;using System.Collections.Generic;using System.Linq;using System ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwVyBM.html" rel="bookmark" class="title">file-java如何获得File&lpar;文件内容已知&rpar;对象</a>
					<div>
						问题描述 java如何获得File(文件内容已知)对象 已知一个String fileContent = &quot;12345678&quot;; 获得一个File对象,该File对象的文件内容就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjWlQM.html" rel="bookmark" class="title">浙商：选择哪里的房产投资</a>
					<div>
						一个城市的房价走势主要看这个城市的扩张能力和经济发展态势.五年内还不涨不跌的城市的房子千万不能碰. 天下浙商网11月16日消息(&lt;浙商&gt;见习记者 俞越报道):未来房价会不会跌?现在还能进行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJGqqp.html" rel="bookmark" class="title">java-Java注册页面的手机短信验证</a>
					<div>
						问题描述 Java注册页面的手机短信验证 如何实现该功能?一定要接口么?谢谢大神指教,最近要实现一个短信验证功能 解决方案 我之前的公司与运营商建立了合作关系,他们给我一个mysql数据库IP地址以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgPaoM.html" rel="bookmark" class="title">华硕&OpenCurlyDoubleQuote;芯片门&rdquo;天价索赔案再起风波</a>
					<div>
						□ 何 军 2006年3月,首都经贸大学大三女生黄静因在售后服务中与华硕公司发生分歧,在协商未果的情况下黄静提出500万美金天价索赔.在此期间,中国消费者协会律师团团长.著名维权律师邱宝昌多次代表华硕 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22gOQb.html" rel="bookmark" class="title">峰任&colon;这么做网络推广&comma;效果想不好都难&excl;</a>
					<div>
						在当今互联网横行的时代,网络推广逐渐成为一种趋势,对于网络这块大蛋糕,谁都想到上来分杯羹,可是,要怎样做才能效果更好呢?才能在茫茫网络人海中找到自己的精准客户呢? 峰任,在推广行业有十余年的发展经验, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
